Package com.sas.lsaf.clinical.model

## Class AttributeMetadata

- java.lang.Object
- - com.sas.lsaf.clinical.model.AttributeMetadata

- All Implemented Interfaces:
    `java.io.Serializable`

      public class AttributeMetadata
      extends java.lang.Object
      implements java.io.Serializable

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AttributeMetadata​(java.lang.String id, java.lang.String name, java.lang.String sasName, java.lang.String description, int ordering, ModelConstants.DataType dataType, int length, ValueListMetadata valueList, int sortSequence, int keySequence, boolean required, boolean contributesToDefine, ModelConstants.LogicalType logicalType, ModelConstants.AttributeScope scope, boolean derived, java.lang.String help, ModelConstants.AttributeState state, boolean mustBeUnique)` | It is not intended or recommended that the consumer of this API construct these objects.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `contributesToDefine()` | Gets whether the attribute contributes to a Define-XML file.
    `boolean` | `equals​(java.lang.Object obj)` |
    `ModelConstants.DataType` | `getDataType()` | Gets the type stored by the attribute.
    `java.lang.String` | `getDescription()` | Gets the text that is used as the label if exported to a SAS data set.
    `java.lang.String` | `getHelp()` | Gets the text describing the purpose of the attribute.
    `java.lang.String` | `getId()` | Gets the id of the attribute metadata.
    `int` | `getKeySequence()` | Gets the integer value used to indicate that the attribute is a key for the table.
    `int` | `getLength()` | Gets the maximum length for attribute values.
    `ModelConstants.LogicalType` | `getLogicalType()` | Gets the logical type that enables attribute association with application types when selecting attribute values.
    `java.lang.String` | `getName()` | Gets the name of the attribute.
    `int` | `getOrdering()` | Gets the integer value that represents the display order of the attribute.
    `java.lang.String` | `getSasName()` | Gets the variable name used when exporting to a SAS dataset.
    `ModelConstants.AttributeScope` | `getScope()` | Gets the attribute scope which is based on logical type.
    `int` | `getSortSequence()` | Gets the integer value used to perform multi-level sorting.
    `ModelConstants.AttributeState` | `getState()` | Gets the state of the attribute.
    `ValueListMetadata` | `getValueList()` | Gets the value list metadata for attributes with a predefined set of allowed values.
    `int` | `hashCode()` |
    `boolean` | `isDerived()` | Gets whether the attribute is derived from associated metadata.
    `boolean` | `isRequired()` | Gets whether the attribute is required.
    `boolean` | `mustBeUnique()` | Gets whether the value of the attribute must be unique from other values of the attribute.
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AttributeMetadata

          public AttributeMetadata​(java.lang.String id,
                                   java.lang.String name,
                                   java.lang.String sasName,
                                   java.lang.String description,
                                   int ordering,
                                   ModelConstants.DataType dataType,
                                   int length,
                                   ValueListMetadata valueList,
                                   int sortSequence,
                                   int keySequence,
                                   boolean required,
                                   boolean contributesToDefine,
                                   ModelConstants.LogicalType logicalType,
                                   ModelConstants.AttributeScope scope,
                                   boolean derived,
                                   java.lang.String help,
                                   ModelConstants.AttributeState state,
                                   boolean mustBeUnique)

      It is not intended or recommended that the consumer of this API construct these objects. They should only deal with the attribute metadata returned by the API.
      Parameters:
        `id` - The id of the attribute metadata.
        `name` - The name of the attribute.
        `sasName` - The variable name used when exporting to a SAS dataset.
        `description` - The text that is used as the label if exported to a SAS data set.
        `ordering` - The integer value that represents the display order of the attribute.
        `dataType` - The type stored by the attribute.
        `length` - The maximum length in characters for string attribute values or number of digits for numeric attribute values.
        `valueList` - The value list metadata for attributes with a predefined set of allowed values.
        `sortSequence` - The integer value used to perform multi-level sorting.
        `keySequence` - The integer value used to indicate that the attribute is a key for the table. It also provides an ordering for the keys.
        `required` - Whether the attribute is required.
        `contributesToDefine` - Whether the attribute contributes to a Define-XML file.
        `logicalType` - The logical type that enables attribute association with application types when selecting attribute values.
        `scope` - Based on logical type, the scope determines if attributes are global or can only be determined from a context, such as user or principal.
        `derived` - Whether the attribute is derived from associated metadata. For example, the count of child objects.
        `help` - The text describing the purpose of the attribute.
        `state` - The state of the attribute. For example, active or retired.
        `mustBeUnique` - Whether the value of the attribute must be unique from other values of the attribute.

  - ### Method Detail

    - #### getId

          public java.lang.String getId()

      Gets the id of the attribute metadata.
      Returns:
        The id of the attribute metadata.

    - #### getName

          public java.lang.String getName()

      Gets the name of the attribute.
      Returns:
        The name of the attribute.

    - #### getSasName

          public java.lang.String getSasName()

      Gets the variable name used when exporting to a SAS dataset. This name conforms to SAS variable name rules.
      Returns:
        The variable name used when exporting to a SAS dataset.

    - #### getDescription

          public java.lang.String getDescription()

      Gets the text that is used as the label if exported to a SAS data set.
      Returns:
        The text that is used as the label if exported to a SAS data set.

    - #### getOrdering

          public int getOrdering()

      Gets the integer value that represents the display order of the attribute.
      Returns:
        The integer value that represents the display order of the attribute.

    - #### getDataType

          public ModelConstants.DataType getDataType()

      Gets the type stored by the attribute.
      Returns:
        The type stored by the attribute.

    - #### getLength

          public int getLength()

      Gets the maximum length for attribute values. For String attribute values, the length is returned in characters. For numeric attribute values, the length is returned in number of digits.
      Returns:
        The maximum length for attribute values.

    - #### getValueList

          public ValueListMetadata getValueList()

      Gets the value list metadata for attributes with a predefined set of allowed values.
      Returns:
        The value list metadata for attributes with a predefined set of allowed values.

    - #### getSortSequence

          public int getSortSequence()

      Gets the integer value used to perform multi-level sorting.
      Returns:
        The integer value used to perform multi-level sorting.

    - #### getKeySequence

          public int getKeySequence()

      Gets the integer value used to indicate that the attribute is a key for the table. It also provides an ordering for the keys.
      Returns:
        The integer value used to indicate that the attribute is a key for the table.

    - #### isRequired

          public boolean isRequired()

      Gets whether the attribute is required.
      Returns:
        Whether the attribute is required.

    - #### isDerived

          public boolean isDerived()

      Gets whether the attribute is derived from associated metadata. For example, the count of child objects.
      Returns:
        Whether the attribute is derived from associated metadata. For example, the count of child objects.

    - #### contributesToDefine

          public boolean contributesToDefine()

      Gets whether the attribute contributes to a Define-XML file.
      Returns:
        Whether the attribute contributes to a Define-XML file.

    - #### mustBeUnique

          public boolean mustBeUnique()

      Gets whether the value of the attribute must be unique from other values of the attribute.
      Returns:
        Whether the value of the attribute must be unique from other values of the attribute.

    - #### getLogicalType

          public ModelConstants.LogicalType getLogicalType()

      Gets the logical type that enables attribute association with application types when selecting attribute values.
      Returns:
        The logical type that enables attribute association with application types when selecting attribute values.

    - #### getScope

          public ModelConstants.AttributeScope getScope()

      Gets the attribute scope which is based on logical type. The scope determines if attributes are global or can only be determined from a context, such as user or principal.
      Returns:
        The attribute scope which is based on logical type.

    - #### getState

          public ModelConstants.AttributeState getState()

      Gets the state of the attribute. For example, active or retired. A retired attribute is one that was used in a release but has since been replaced by another attribute or deprecated. Attributes marked as retired are not returned, validated. or imported when specified.
      Returns:
        The state of the attribute.

    - #### getHelp

          public java.lang.String getHelp()

      Gets the text describing the purpose of the attribute.
      Returns:
        The text describing the purpose of the attribute.

    - #### equals

          public boolean equals​(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`